##############################################################################
#
# Copyright (c) 2003 - Tue Wennerberg - All Rights Reserved
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

__doc__='''ZTimeReg Product Initialization'''

import Products.ZTimeReg.Root
import Products.ZTimeReg.Customer
import Products.ZTimeReg.Account
import Products.ZTimeReg.Project
import Products.PythonScripts.Utility

# Initialize product
def initialize(context):

    # Register class
    context.registerClass(
        Root.Root,
        icon = 'images/timereg_root_icon.gif',
        constructors = (Root.manage_addRootForm,
                        Root.manage_addRoot),
        container_filter =
            lambda x: x.meta_type not in ['TimeReg System',
                                          'TimeReg Customer',
                                          'TimeReg Account',
                                          'TimeReg Project'],
    )
    
    # Register class
    context.registerClass(
        Customer.Customer,
        constructors = (Customer.manage_addCustomerForm,
                        Customer.manage_addCustomer),
        container_filter = lambda x: x.meta_type not in ['TimeReg Customer',
                                                         'TimeReg Account',
                                                         'TimeReg Project'],
    )

    # Register class
    context.registerClass(
        Account.Account,
        constructors = (Account.manage_addAccountForm,
                        Account.manage_addAccount),
        container_filter = lambda x: x.meta_type=='TimeReg Customer',
    )

    # Register class
    context.registerClass(
        Project.Project,
        constructors = (Project.manage_addProjectForm,
                        Project.manage_addProject),
        container_filter = lambda x: x.meta_type=='TimeReg Account',
    )

    # Allow using time utilities from python scripts
    Products.PythonScripts.Utility.allow_module('Products.ZTimeReg.TimeUtils')
