## Script (Python) "calculateAccounts"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=customer
##title=
##
# Lookup accounts - Result is grouped by day,account

result = container.lookupAccounts_sql(regs_table=container.regs_table,
                                      customer=customer)


mydict = {}
for row in result.dictionaries():
    date = row['reg_date']
    if not mydict.has_key(date):
        mydict[date] = []
    mydict[date].append(row)


dates = mydict.keys()
dates.sort()
mylist = []
total_rounded = 0
for date in dates:
    rows = mydict[date]
    day_sum = 0
    day_sum_rounded = 0
    for row in rows:
        warning = None
        account = container.getAccount(row['reg_customer'], row['reg_account'])
        if account is not None:
            rprec = account.rounding_precision
            rmeth = account.rounding_method
        else:
            warning = "Couldn't find account info"
            rprec = 1
            rmeth = 'round'
        row['elapsed_sum_rounded'] = container.round(row['elapsed_sum'],
                                                     precision=rprec,
                                                     method=rmeth)
        row['warning'] = warning
        day_sum = day_sum + row['elapsed_sum']
        day_sum_rounded = day_sum_rounded + row['elapsed_sum_rounded']
    total_rounded = total_rounded + day_sum_rounded
    mylist.append( { 
                     'date':date, 'rows':rows, 
                     'sums':{'day_sum':day_sum,'day_sum_rounded':day_sum_rounded},
                   } )    

return {'entries':mylist,'total_rounded':total_rounded}
