## Script (Python) "insertRegistration"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
from Products.ZTimeReg.TimeUtils import decode_time

r = context.REQUEST
username = context.getUsername()
if username=="Anonymous User":
    return "No access for anonymous users."

date = "%(year)d-%(month)02d-%(day)02d" % r

if len(r['account_and_project'])==0:
    raise ValueError, "Empty account and project value in request"
pair = r['account_and_project'].split('/')
if len(pair) != 2:
    raise ValueError, "Malformed account_and_project value"
account = pair[0]
if len(account)==0:
    raise ValueError, "Empty account value in request"
project = pair[1]
if len(project)==0:
    raise ValueError, "Empty project value in request"

if len(r['begin'])>0 and len(r['end'])>0 and len(r['pause'])>0 and len(r['time'])==0:
    begin = decode_time(r['begin'])
    end   = decode_time(r['end'])
    pause = decode_time(r['pause'])
    time  = 0
    if begin > 24*60:
        raise ValueError, "Begin value is greater than 24 hours"
    if end > 24*60:
        raise ValueError, "End value is greater than 24 hours"
    if begin >= end:
        raise ValueError, "Begin value should come before end value (%(begin)s-%(end)s)" % r
    if pause >= end-begin:
        raise ValueError, "Pause value should be less than time span"
    res = context.lookupExistingRegs_sql(regs_table=container.regs_table,
                                         username=username,
                                         date=date,begin=begin,end=end)
    if len(res)>0:
        raise ValueError, "An overlapping registration already exists at this time for this user"
elif len(r['begin'])==0 and len(r['end'])==0 and len(r['pause'])==0 and len(r['time'])>0:
    begin = 0
    end   = 0
    pause = 0
    time  = decode_time(r['time'])
    if time > 24*60:
        raise ValueError, "Time value is greater than 24 hours"
else:
    raise ValueError, "You need to specify either begin/end/pause or time, but not both"



context.insertRegistration_sql(username = username,
                               customer = r['customer'],
                               project  = project,
                               account  = account,
                               date     = date,
                               begin    = begin,
                               end      = end,
                               time     = time,
                               pause    = pause )

r.RESPONSE.redirect(r['URL1'] + '/register')
